% Find the ACI comparing the EW model likelihoods to ours
%==========================================================================

%==========================================================================
% Prameters 
%==========================================================================
ind=1000;
spells=10;
% B - HSINC
parameters_BHSINC = parameters_ew('B','HSINC');
% W - HSINC
parameters_WHSINC = parameters_ew('W','HSINC');
% B - HSGRD
parameters_BHSGRD = parameters_ew('B','HSGRD');
% W - HSGRD
parameters_WHSGRD = parameters_ew('W','HSGRD');
% B - COLINC
parameters_BCOLINC = parameters_ew('B','COLINC');
% W - COLINC
parameters_WCOLINC = parameters_ew('W','COLINC');
% W - COLGRD
parameters_WCOLGRD = parameters_ew('W','COLGRD');
%==========================================================================
% get simulated data 
%==========================================================================
[wage_BHSINC,duration_BHSINC] = simulation_ew(parameters_BHSINC,1234,spells,ind);
[wage_BHSGRD,duration_BHSGRD] = simulation_ew(parameters_BHSGRD,1234,spells,ind);
[wage_BCOLINC,duration_BCOLINC] = simulation_ew(parameters_BCOLINC,1234,spells,ind);
[wage_WHSINC,duration_WHSINC] = simulation_ew(parameters_WHSINC,1234,spells,ind);
[wage_WHSGRD,duration_WHSGRD] = simulation_ew(parameters_WHSGRD,1234,spells,ind);
[wage_WCOLINC,duration_WCOLINC] = simulation_ew(parameters_WCOLINC,1234,spells,ind);
[wage_WCOLGRD,duration_WCOLGRD] = simulation_ew(parameters_WCOLGRD,1234,spells,ind);

%==========================================================================
% Find the likelihood of the EW data
%==========================================================================
log_like_BHSINC = ew_likelihood([wage_BHSINC,duration_BHSINC], parameters_BHSINC);
log_like_BHSGRD = ew_likelihood([wage_BHSGRD,duration_BHSGRD], parameters_BHSGRD);
log_like_BCOLINC = ew_likelihood([wage_BCOLINC,duration_BCOLINC], parameters_BCOLINC);
log_like_WHSINC = ew_likelihood([wage_WHSINC,duration_WHSINC], parameters_WHSINC);
log_like_WHSGRD = ew_likelihood([wage_WHSGRD,duration_WHSGRD], parameters_WHSGRD);
log_like_WCOLINC = ew_likelihood([wage_WCOLINC,duration_WCOLINC], parameters_WCOLINC);
log_like_WCOLGRD = ew_likelihood([wage_WCOLGRD,duration_WCOLGRD], parameters_WCOLGRD);

EW_likelihood = log_like_BHSINC+log_like_BHSGRD+log_like_BCOLINC+log_like_WHSINC+log_like_WHSGRD+log_like_WCOLINC+log_like_WCOLGRD;


%==========================================================================
% Find AIC
%==========================================================================
load('ew_exp_2types.mat', 'log_likelihood')
log_likelihood_2types = log_likelihood;
load('ew_exp_3types.mat', 'log_likelihood')
log_likelihood_3types = log_likelihood;
load('ew_exp_4types.mat', 'log_likelihood')
log_likelihood_4types = log_likelihood;
load('ew_exp_5types.mat', 'log_likelihood2')
log_likelihood_5types = log_likelihood2;

EW_AIC = 2*(23*7) - 2*EW_likelihood;
Exp2_AIC = 2*(26) - 2*(-log_likelihood_2types);
Exp3_AIC = 2*(48) - 2*(-log_likelihood_3types);
Exp4_AIC = 2*(88) - 2*(-log_likelihood_4types);
Exp5_AIC = 2*(152) - 2*(-log_likelihood_5types);

AICs = [EW_AIC,Exp2_AIC,Exp3_AIC,Exp4_AIC,Exp5_AIC];