function [ KL,KL_1,KL_2,other ] = KLdiv( parameters, group, type , seed, N )
% Calculates the KL divergence from EW model
rng(seed)
% assign parameters
gamma1 = parameters(1);
Prob1 =  parameters(2);
mu1 =    parameters(3);
res_m1 = parameters(4);
gamma2 = parameters(5);
Prob2 =  parameters(6);
mu2 =    parameters(7);
res_m2 = parameters(8);
gamma3 = parameters(9);
Prob3 =  parameters(10);
mu3 =    parameters(11);
res_m3 = parameters(12);
gamma4 = parameters(13);
Prob4 =  parameters(14);
mu4 =    parameters(15);
res_m4 = parameters(16);
gamma5 = parameters(17);
Prob5 =  parameters(18);
mu5 =    parameters(19);
res_m5 = parameters(20);
var_m =  parameters(21);
var_u =  parameters(22);
rho =    parameters(23);

% find total variance and sd
sigma_m = sqrt(var_m);
var_t = var_m+var_u;
sigma_t = sqrt(var_t);

%--------------------------------------------------------------------------
% find the probabilities 
%--------------------------------------------------------------------------
t = linspace(0,10000,N);
pt_ew1 = ((1-Prob1.*(1-normcdf((log(0.5*res_m1) - (log(0.5) + mu1))/(rho*sigma_t)))).^t).*(Prob1.*(1-normcdf((log(0.5*res_m1) - (log(0.5) + mu1))/(rho*sigma_t))));
pt_ew2 = ((1-Prob2.*(1-normcdf((log(0.5*res_m2) - (log(0.5) + mu2))/(rho*sigma_t)))).^t).*(Prob2.*(1-normcdf((log(0.5*res_m2) - (log(0.5) + mu2))/(rho*sigma_t))));
pt_ew3 = ((1-Prob3.*(1-normcdf((log(0.5*res_m3) - (log(0.5) + mu3))/(rho*sigma_t)))).^t).*(Prob3.*(1-normcdf((log(0.5*res_m3) - (log(0.5) + mu3))/(rho*sigma_t))));
pt_ew4 = ((1-Prob4.*(1-normcdf((log(0.5*res_m4) - (log(0.5) + mu4))/(rho*sigma_t)))).^t).*(Prob4.*(1-normcdf((log(0.5*res_m4) - (log(0.5) + mu4))/(rho*sigma_t))));
pt_ew5 = ((1-Prob5.*(1-normcdf((log(0.5*res_m5) - (log(0.5) + mu5))/(rho*sigma_t)))).^t).*(Prob5.*(1-normcdf((log(0.5*res_m5) - (log(0.5) + mu5))/(rho*sigma_t))));

pt_ew = gamma1*pt_ew1 + gamma2*pt_ew2 + gamma3*pt_ew3 + gamma4*pt_ew4 + gamma5*pt_ew5;

%--------------------------
% Find our probababilities
%--------------------------
%load the estimates
load(strcat('ew_exp_',type,'types.mat'), 'ests')

%covariates determined by group
if strcmp(group,'BHSINC')
    cov = [1,0,0,0];
elseif strcmp(group,'BHSGRD')
    cov = [1,1,0,0];
elseif strcmp(group,'BCOLINC')
    cov = [1,0,1,0];
elseif strcmp(group,'WHSINC')
    cov = [0,0,0,0];
elseif strcmp(group,'WHSGRD')
    cov = [0,1,0,0];
elseif strcmp(group,'WCOLINC')
    cov = [0,0,1,0];
elseif strcmp(group,'WCOLGRD')
    cov = [0,0,0,1];
else
    disp('No valid group selected')
    return
end

% find probabilities
if strcmp(type,'2')
    lamL = ests(9);
    lamM = ests(10);
    lamH = ests(11);

    V1L = ests(12);
    V1M = ests(13);
    V1H = ests(14);

    beta1 = ests(15);
    beta2 = ests(16);
    beta3 = ests(17);
    beta4 = ests(18);
    beta5 = ests(19);
    beta6 = ests(20);
    beta7 = ests(21);
    beta8 = ests(22);
    beta9 = ests(23);
    beta10 = ests(24);
    beta11 = ests(25);
    beta12 = ests(26);

    BetaL = [ beta1, beta2, beta3, beta4]';
    BetaM = [ beta5, beta6, beta7, beta8]';
    BetaH = [ beta9, beta10,beta11,beta12]';

    %create matrix of unbservable types
    types = permn([1,2],3);
    types(types(:,1) == 2,1) = V1L;
    types(types(:,2) == 2,2) = V1M;
    types(types(:,3) == 2,3) = V1H;

    %probabilities
    pt_begr = nan(1,N);
    for k = 1:N
     pt_begr(k) = ests(1:8)*(sum(types.*repmat([lamL*exp(cov*BetaL),lamM*exp(cov*BetaM),lamH*exp(cov*BetaH)],8,1),2).*exp(-sum(types.*repmat([lamL*exp(cov*BetaL),lamM*exp(cov*BetaM),lamH*exp(cov*BetaH)],8,1),2)*t(k)));
    end
    
elseif strcmp(type,'3')
    lamL = ests(28);
    lamM = ests(29);
    lamH = ests(30);

    V1L = ests(31);
    V2L = ests(32);

    V1M = ests(33);
    V2M = ests(34);

    V1H = ests(35);
    V2H = ests(36);

    beta1 = ests(37);
    beta2 = ests(38);
    beta3 = ests(39);
    beta4 = ests(40);
    beta5 = ests(41);
    beta6 = ests(42);
    beta7 = ests(43);
    beta8 = ests(44);
    beta9 = ests(45);
    beta10 = ests(46);
    beta11 = ests(47);
    beta12 = ests(48);


    BetaL = [ beta1, beta2, beta3, beta4]';
    BetaM = [ beta5, beta6, beta7, beta8]';
    BetaH = [ beta9, beta10,beta11,beta12]';

    %create matrix of unbservable types
    types = permn([1,2,3],3);
    types(types(:,1) == 2,1) = V1L;
    types(types(:,1) == 3,1) = V2L;
    types(types(:,2) == 2,2) = V1M;
    types(types(:,2) == 3,2) = V2M;
    types(types(:,3) == 2,3) = V1H;
    types(types(:,3) == 3,3) = V2H;
    
    %probabilities
    pt_begr = nan(1,N);
    for k = 1:N
     pt_begr(k) = ests(1:27)*(sum(types.*repmat([lamL*exp(cov*BetaL),lamM*exp(cov*BetaM),lamH*exp(cov*BetaH)],27,1),2).*exp(-sum(types.*repmat([lamL*exp(cov*BetaL),lamM*exp(cov*BetaM),lamH*exp(cov*BetaH)],27,1),2)*t(k)));
    end
    
elseif strcmp(type,'4')
    lamL = ests(65);
    lamM = ests(66);
    lamH = ests(67);

    V1L = ests(68);
    V2L = ests(69);
    V3L = ests(70);

    V1M = ests(71);
    V2M = ests(72);
    V3M = ests(73);

    V1H = ests(74);
    V2H = ests(75);
    V3H = ests(76);

    beta1 = ests(77);
    beta2 = ests(78);
    beta3 = ests(79);
    beta4 = ests(80);
    beta5 = ests(81);
    beta6 = ests(82);
    beta7 = ests(83);
    beta8 = ests(84);
    beta9 = ests(85);
    beta10 = ests(86);
    beta11 = ests(87);
    beta12 = ests(88);


    BetaL = [ beta1, beta2, beta3, beta4]';
    BetaM = [ beta5, beta6, beta7, beta8]';
    BetaH = [ beta9, beta10,beta11,beta12]';

    %create matrix of unbservable types
    types = permn([1,2,3,4],3);
    types(types(:,1) == 2,1) = V1L;
    types(types(:,1) == 3,1) = V2L;
    types(types(:,1) == 4,1) = V3L;
    types(types(:,2) == 2,2) = V1M;
    types(types(:,2) == 3,2) = V2M;
    types(types(:,2) == 4,2) = V3M;
    types(types(:,3) == 2,3) = V1H;
    types(types(:,3) == 3,3) = V2H;
    types(types(:,3) == 4,3) = V3H;
    
    %probabilities
    pt_begr = nan(1,N);
    for k = 1:N
     pt_begr(k) = ests(1:64)*(sum(types.*repmat([lamL*exp(cov*BetaL),lamM*exp(cov*BetaM),lamH*exp(cov*BetaH)],64,1),2).*exp(-sum(types.*repmat([lamL*exp(cov*BetaL),lamM*exp(cov*BetaM),lamH*exp(cov*BetaH)],64,1),2)*t(k)));
    end
    
elseif strcmp(type,'5')
    beta1 = ests(141);
    beta2 = ests(142);
    beta3 = ests(143);
    beta4 = ests(144);
    beta5 = ests(145);
    beta6 = ests(146);
    beta7 = ests(147);
    beta8 = ests(148);
    beta9 = ests(149);
    beta10 = ests(150);
    beta11 = ests(151);
    beta12 = ests(152);

    BetaL = [ beta1, beta2, beta3, beta4]';
    BetaM = [ beta5, beta6, beta7, beta8]';
    BetaH = [ beta9, beta10,beta11,beta12]';

    V1L = ests(129);
    V2L = ests(130);
    V3L = ests(131);
    V4L = ests(132);

    V1M = ests(133);
    V2M = ests(134);
    V3M = ests(135);
    V4M = ests(136);

    V1H = ests(137);
    V2H = ests(138);
    V3H = ests(139);
    V4H = ests(140);

    lamL = ests(126);
    lamM = ests(127);
    lamH = ests(128);

    %create matrix of unbservable types
    types = permn([1,2,3,4,5],3);
    types(types(:,1) == 2,1) = V1L;
    types(types(:,1) == 3,1) = V2L;
    types(types(:,1) == 4,1) = V3L;
    types(types(:,1) == 5,1) = V4L;
    types(types(:,2) == 2,2) = V1M;
    types(types(:,2) == 3,2) = V2M;
    types(types(:,2) == 4,2) = V3M;
    types(types(:,2) == 5,2) = V4M;
    types(types(:,3) == 2,3) = V1H;
    types(types(:,3) == 3,3) = V2H;
    types(types(:,3) == 4,3) = V3H;
    types(types(:,3) == 5,3) = V4H;
    
    %probabilities
    pt_begr = nan(1,N);
    for k = 1:N
     pt_begr(k) = ests(1:125)*(sum(types.*repmat([lamL*exp(cov*BetaL),lamM*exp(cov*BetaM),lamH*exp(cov*BetaH)],125,1),2).*exp(-sum(types.*repmat([lamL*exp(cov*BetaL),lamM*exp(cov*BetaM),lamH*exp(cov*BetaH)],125,1),2)*t(k)));
    end
end

%--------------------------------------------------------------------------
% Plot figure
%--------------------------------------------------------------------------
% find location of t closest to 30 quarters
xaxis_end = find(t<=15,1,'last');

% get colors
colors = get(gca,'ColorOrder');
close;

% plot
f = figure(1);
set(gca, 'ColorOrder', [colors(1,:);colors(7,:)], 'NextPlot', 'replacechildren');
plot(t(1:xaxis_end),pt_ew(1:xaxis_end),t(1:xaxis_end),pt_begr(1:xaxis_end),'LineWidth',2)
l = legend('EW',strcat('Model- ', type,' types'));
% title(strcat('Probability Distribution Function: ', group),'FontSize',20)
set(l,'FontSize',17)
xlabel('Duration of Unemployment, Quarters','FontSize',17)
xt = get(gca, 'XTick');
set(gca, 'FontSize', 17)
f.PaperPosition = [0,0,12,4.5];

% save
cd '../../writeup/figures'
print(strcat(group,'_',type','types.eps'),'-depsc','-loose')
cd ../../model/new

close;  
%--------------------------------------------------------------------------
% calculate the KL divergence
%--------------------------------------------------------------------------
last_begr = find(pt_begr>0,1,'last');
last_ew = find(pt_ew>0,1,'last');
last = min(last_ew,last_begr);
diff = t(2:last)-t(1:last-1);

ew_norm1 = sum(diff.*pt_ew(1:last-1));
begr_norm1 = sum(diff.*pt_begr(1:last-1));

ew_norm2 = sum(diff.*pt_ew(2:last));
begr_norm2 = sum(diff.*pt_begr(2:last));

KL_1 = sum(diff.*(pt_ew(1:last-1)/ew_norm1).*log((pt_ew(1:last-1)/ew_norm1)./(pt_begr(1:last-1)/begr_norm1)));
KL_2 = sum(diff.*(pt_ew(2:last)/ew_norm2).*log((pt_ew(2:last)/ew_norm2)./(pt_begr(2:last)/begr_norm2)));

KL = (KL_1+KL_2)/2;

other1 = sum(diff.*(pt_ew(1:last-1)/ew_norm1).*log((pt_ew(1:last-1)/ew_norm1)));
other2 = sum(diff.*(pt_ew(2:last)/ew_norm2).*log((pt_ew(2:last)/ew_norm2)));

other = (other1+other2)/2;
end

