%%Bootstrap 2 types
Ests = NaN(500,26);
Haz = NaN(500,7);
options = optimset('MaxIter',10000,'MaxFunEvals',30000,'Algorithm','interior-point','UseParallel','always');
rng(100);
index = ceil(unifrnd(0,7000,7000,500));
parfor k =1:500
    struct = load('ew_simulated_data.mat');
    data = struct.data;
    newdata = data(index(:,k),:);

    init_guess = [0.126620475936700,0.00328211101011295,0.000575924426015460,0.0965234728779089,0.316345211972248,0.0545820288154946,0.126159345388812,0.275911429572709,1.01269477704343,0.220031908493266,0.0524750540502142,0.0352030299338329,0.109254184113936,0.0446461932432434,-0.271468686945157,0.365949388806645,-1.75593117059183,-0.905778283358297,-0.614453683963101,0.958774156831071,1.87241238684231,0.661412678186082,-0.936368868716679,1.05675683822269,3.28771938969194,2.17693461325866];

    Aeq = [ones(1,8),zeros(1,18)];
    beq = 1;
    lb = [.0000001*ones(8,1);.000001*ones(6,1);-20*ones(12,1)];
    ub = [.9999999*ones(8,1); 10000*ones(3,1);10*ones(3,1);20*ones(12,1)];

    [ests,log_likelihood,exitflag,output,lambda,grad,hess] =  fmincon(@(z) log_like_6_2types(z,newdata),init_guess,[],[],Aeq,beq,lb,ub,[],options);

    Ests(k,:) = ests;

    lamL = ests(9);
    lamM = ests(10);
    lamH = ests(11);

    V1L = ests(12);
    V1M = ests(13);
    V1H = ests(14);

    beta1 = ests(15);
    beta2 = ests(16);
    beta3 = ests(17);
    beta4 = ests(18);
    beta5 = ests(19);
    beta6 = ests(20);
    beta7 = ests(21);
    beta8 = ests(22);
    beta9 = ests(23);
    beta10 = ests(24);
    beta11 = ests(25);
    beta12 = ests(26);


    BetaL = [ beta1, beta2, beta3, beta4]';
    BetaM = [ beta5, beta6, beta7, beta8]';
    BetaH = [ beta9, beta10,beta11,beta12]';


    %create matrix of unbservable types
    types = permn([1,2],3);
    types(types(:,1) == 2,1) = V1L;
    types(types(:,2) == 2,2) = V1M;
    types(types(:,3) == 2,3) = V1H;

    est_haz_BHSINC = ests(1:8)*sum(types.*repmat([lamL*exp(cov_BHSINC*BetaL), lamM*exp(cov_BHSINC*BetaM), lamH*exp(cov_BHSINC*BetaH)],8,1),2);
    est_haz_BHSGRD = ests(1:8)*sum(types.*repmat([lamL*exp(cov_BHSGRD*BetaL), lamM*exp(cov_BHSGRD*BetaM), lamH*exp(cov_BHSGRD*BetaH)],8,1),2);
    est_haz_BCOLINC = ests(1:8)*sum(types.*repmat([lamL*exp(cov_BCOLINC*BetaL), lamM*exp(cov_BCOLINC*BetaM), lamH*exp(cov_BCOLINC*BetaH)],8,1),2);
    est_haz_WHSINC = ests(1:8)*sum(types.*repmat([lamL*exp(cov_WHSINC*BetaL), lamM*exp(cov_WHSINC*BetaM), lamH*exp(cov_WHSINC*BetaH)],8,1),2);
    est_haz_WHSGRD = ests(1:8)*sum(types.*repmat([lamL*exp(cov_WHSGRD*BetaL), lamM*exp(cov_WHSGRD*BetaM), lamH*exp(cov_WHSGRD*BetaH)],8,1),2);
    est_haz_WCOLINC = ests(1:8)*sum(types.*repmat([lamL*exp(cov_WCOLINC*BetaL), lamM*exp(cov_WCOLINC*BetaM), lamH*exp(cov_WCOLINC*BetaH)],8,1),2);
    est_haz_WCOLGRD = ests(1:8)*sum(types.*repmat([lamL*exp(cov_WCOLGRD*BetaL), lamM*exp(cov_WCOLGRD*BetaM), lamH*exp(cov_WCOLGRD*BetaH)],8,1),2);
    
    est_haz = [est_haz_BHSINC,est_haz_BHSGRD,est_haz_BCOLINC,est_haz_WHSINC,est_haz_WHSGRD,est_haz_WCOLINC,est_haz_WCOLGRD];
    Haz(k,:) = est_haz;
    
end
save('bootstrap_2types','Ests','Haz');

