function [ log_likelihood ] = ew_likelihood( data, parameters )
%EW likelihood function

% assign parameters
gamma1 = parameters(1);
P1     = parameters(2);
mu1    = parameters(3);
res_m1 = parameters(4);
gamma2 = parameters(5);
P2     = parameters(6);
mu2    = parameters(7);
res_m2 = parameters(8);
gamma3 = parameters(9);
P3     = parameters(10);
mu3    = parameters(11);
res_m3 = parameters(12);
gamma4 = parameters(13);
P4     = parameters(14);
mu4    = parameters(15);
res_m4 = parameters(16);
gamma5 = parameters(17);
P5     = parameters(18);
mu5    = parameters(19);
res_m5 = parameters(20);
var_m  = parameters(21);
var_u  = parameters(22);
rho    = parameters(23);

% find total variance and sd
var_t = var_m+var_u;
sigma_t = sqrt(var_t);

% assign data
w0 = data(:,1:10);
dt = data(:,11:20);

log_likelihood = sum(log(...
    gamma1.*sum(((1-P1.*(1-normcdf((log(0.5.*res_m1) - (log(0.5) + mu1))./(rho.*sigma_t)))).^dt).*P1.*(1-normcdf((log(0.5.*res_m1) - (rho^2).*log(w0) - (1-rho^2).*(log(0.5) + mu1))./(rho.*sigma_t.*(1-rho^2)^(0.5)))).*(1./w0).*(1./sigma_t).*normpdf((log(w0) - (log(0.5) + mu1))./sigma_t),2) + ...
    gamma2.*sum(((1-P2.*(1-normcdf((log(0.5.*res_m2) - (log(0.5) + mu2))./(rho.*sigma_t)))).^dt).*P2.*(1-normcdf((log(0.5.*res_m2) - (rho^2).*log(w0) - (1-rho^2).*(log(0.5) + mu2))./(rho.*sigma_t.*(1-rho^2)^(0.5)))).*(1./w0).*(1./sigma_t).*normpdf((log(w0) - (log(0.5) + mu2))./sigma_t),2) + ...
    gamma3.*sum(((1-P3.*(1-normcdf((log(0.5.*res_m3) - (log(0.5) + mu3))./(rho.*sigma_t)))).^dt).*P3.*(1-normcdf((log(0.5.*res_m3) - (rho^2).*log(w0) - (1-rho^2).*(log(0.5) + mu3))./(rho.*sigma_t.*(1-rho^2)^(0.5)))).*(1./w0).*(1./sigma_t).*normpdf((log(w0) - (log(0.5) + mu3))./sigma_t),2) + ...
    gamma4.*sum(((1-P4.*(1-normcdf((log(0.5.*res_m4) - (log(0.5) + mu4))./(rho.*sigma_t)))).^dt).*P4.*(1-normcdf((log(0.5.*res_m4) - (rho^2).*log(w0) - (1-rho^2).*(log(0.5) + mu4))./(rho.*sigma_t.*(1-rho^2)^(0.5)))).*(1./w0).*(1./sigma_t).*normpdf((log(w0) - (log(0.5) + mu4))./sigma_t),2) + ...
    gamma5.*sum(((1-P5.*(1-normcdf((log(0.5.*res_m5) - (log(0.5) + mu5))./(rho.*sigma_t)))).^dt).*P5.*(1-normcdf((log(0.5.*res_m5) - (rho^2).*log(w0) - (1-rho^2).*(log(0.5) + mu5))./(rho.*sigma_t.*(1-rho^2)^(0.5)))).*(1./w0).*(1./sigma_t).*normpdf((log(w0) - (log(0.5) + mu5))./sigma_t),2)));
end

