function [ param ] = parameters_ew( race, education )
%returns parameter values for 

if strcmp(race,'B')
    if strcmp(education,'HSINC')
        %------------------------------------------------------------------
        % B - HSINC
        %------------------------------------------------------------------
        gamma1 = 0.01;
        P1 = 0.99;
        mu1 = 5.69;
        res_m1 = 544.47;
        gamma2 = 0.1;
        P2 = 0.99;
        mu2 = 8.50;
        res_m2 = 0;
        gamma3 = 0.19;
        P3 = 0.99;
        mu3 = 7.88;
        res_m3 = 3909.12;
        gamma4 = 0.3;
        P4 = 0.99;
        mu4 = 6.81;
        res_m4 = 2412.64;
        gamma5 = 0.39;
        P5 = 0.99;
        mu5 = 7.59;
        res_m5 = 3569.88;
        var_m = 0.28;
        var_u = 0.02;
        rho = 0.96;
    elseif strcmp(education,'HSGRD')
        %------------------------------------------------------------------
        % B - HSGRD
        %------------------------------------------------------------------          
        gamma1 = 0.03;
        P1 = 0.22;
        mu1 = 6.31;
        res_m1 = 346.18;
        gamma2 = 0.12;
        P2 = 0.99;
        mu2 = 6.55;
        res_m2 = 2094.73;
        gamma3 = 0.16;
        P3 = 0.99;
        mu3 = 8.28;
        res_m3 = 2731.44;
        gamma4 = 0.34;
        P4 = 0.99;
        mu4 = 7.71;
        res_m4 = 3307.42;
        gamma5 = 0.35;
        P5 = 0.99;
        mu5 = 7.31;
        res_m5 = 3447.64;
        var_m = 0.42;
        var_u = 0.01;
        rho = 0.99;
    elseif strcmp(education,'COLINC')
        %------------------------------------------------------------------
        % B - COLINC
        %------------------------------------------------------------------ 
        gamma1 = 0.03;
        P1 = 0.99;
        mu1 = 7.07;
        res_m1 = 1870.31;
        gamma2 = 0.11;
        P2 = 0.99;
        mu2 = 7.89;
        res_m2 = 4448.27;
        gamma3 = 0.18;
        P3 = 0.99;
        mu3 = 8.85;
        res_m3 = 7478.37;
        gamma4 = 0.32;
        P4 = 0.99;
        mu4 = 7.61;
        res_m4 = 2988;
        gamma5 = 0.36;
        P5 = 0.99;
        mu5 = 8.74;
        res_m5 = 3254.76;
        var_m = 0.18;
        var_u = 0;
        rho = 0.99;
    else
        param = nan;
        return
    end
elseif strcmp(race,'W')
    if strcmp(education, 'HSINC')
        %------------------------------------------------------------------
        % W - HSINC
        %------------------------------------------------------------------
        gamma1 = 0.01;
        P1 = 0.99;
        mu1 = 5.51;
        res_m1 = 315.34;
        gamma2 = 0.09;
        P2 = 0.99;
        mu2 = 8.16;
        res_m2 = 0;
        gamma3 = 0.21;
        P3 = 0.99;
        mu3 = 8.04;
        res_m3 = 5757.77;
        gamma4 = 0.29;
        P4 = 0.99;
        mu4 = 7.16;
        res_m4 = 2991.78;
        gamma5 = 0.4;
        P5 = 0.99;
        mu5 = 7.80;
        res_m5 = 3588.69;
        var_m = 0.31;
        var_u = 0.02;
        rho = 0.97;
    elseif strcmp(education,'HSGRD')
        %------------------------------------------------------------------
        % W - HSGRD
        %------------------------------------------------------------------    
        gamma1 = 0.03;
        P1 = 0.07;
        mu1 = 7.2;
        res_m1 = 0;
        gamma2 = 0.11;
        P2 = 0.99;
        mu2 = 8.21;
        res_m2 = 6301.31;
        gamma3 = 0.18;
        P3 = 0.99;
        mu3 = 8.64;
        res_m3 = 0;
        gamma4 = 0.32;
        P4 = 0.99;
        mu4 = 7.55;
        res_m4 = 3154.94;
        gamma5 = 0.36;
        P5 = 0.99;
        mu5 = 8.24;
        res_m5 = 3827.34;
        var_m = 0.25;
        var_u = 0.03;
        rho = 0.94;
    elseif strcmp(education,'COLINC')
        %------------------------------------------------------------------
        % W - COLINC
        %------------------------------------------------------------------
        gamma1 = 0.02;
        P1 = 0.32;
        mu1 = 6.19;
        res_m1 = 523.16;
        gamma2 = 0.13;
        P2 = 0.99;
        mu2 = 8.35;
        res_m2 = 2913.03;
        gamma3 = 0.15;
        P3 = 0.98;
        mu3 = 8.29;
        res_m3 = 6441.9;
        gamma4 = 0.34;
        P4 = 0.99;
        mu4 = 8.79;
        res_m4 = 2910.45;
        gamma5 = 0.35;
        P5 = 0.99;
        mu5 = 7.95;
        res_m5 = 3482.44;
        var_m = 0.37;
        var_u = 0;
        rho = 0.99;
    elseif strcmp(education,'COLGRD')
        %------------------------------------------------------------------
        % W - COLGRD
        %------------------------------------------------------------------
        gamma1 = 0.05;
        P1 = 0.63;
        mu1 = 7.16;
        res_m1 = 310.59;
        gamma2 = 0.07;
        P2 = 0.99;
        mu2 = 7.76;
        res_m2 = 4079.03;
        gamma3 = 0.23;
        P3 = 0.99;
        mu3 = 8.39;
        res_m3 = 4971.57;
        gamma4 = 0.27;
        P4 = 0.69;
        mu4 = 8.65;
        res_m4 = 3111.34;
        gamma5 = 0.37;
        P5 = 0.99;
        mu5 = 8.85;
        res_m5 = 7174.59;
        var_m = 0.21;
        var_u = 0;
        rho = 0.99;
    else 
        param = nan;
        return 
    end
else
    param = nan;
    return
end

param = [gamma1,P1,mu1,res_m1,gamma2,P2,mu2,res_m2,gamma3,P3,mu3,res_m3,gamma4,P4,mu4,res_m4,gamma5,P5,mu5,res_m5,var_m,var_u,rho];
        
end

